/*
////////////////////////////////////////////////

  DV Codec "Iris" DirectShow tB^ CLSID `

  (c) 2002 VSYNC
////////////////////////////////////////////////
*/


#ifndef __IDVIRISDS__
#define __IDVIRISDS__

#ifdef __cplusplus
extern "C" {
#endif

#define DVIRIS_X86	(0)
#define DVIRIS_MMX	(1)
#define DVIRIS_SSE	(2)
#define DVIRIS_SSE2	(3)

// {38345059-0000-0010-8000-00AA00389B71}
DEFINE_GUID(MEDIASUBTYPE_YP48,
0x38345059, 0x0000, 0x0010, 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71);


#ifndef MSDV_COMPATIBLE

// {9CF170C5-5734-440f-A406-7A5530B1AF10}
DEFINE_GUID(CLSID_DVIrisDSDecoder,
0x9cf170c5, 0x5734, 0x440f, 0xa4, 0x6, 0x7a, 0x55, 0x30, 0xb1, 0xaf, 0x10);

#else

DEFINE_GUID(CLSID_DVIrisDSDecoder,
// DV Video Decoder
0xb1b77c00, 0xc3e4, 0x11cf, 0xaf, 0x79, 0x0, 0xaa, 0x0, 0xb6, 0x7a, 0x42);

#endif

#ifndef MSDV_COMPATIBLE

// {F3EA5D91-3C0D-4bce-8323-771F79305852}
DEFINE_GUID(CLSID_DVIrisDSEncoder,
0xf3ea5d91, 0x3c0d, 0x4bce, 0x83, 0x23, 0x77, 0x1f, 0x79, 0x30, 0x58, 0x52);

#else

DEFINE_GUID(CLSID_DVIrisDSEncoder,
// DV Video Encoder
0x13aa3650, 0xbb6f, 0x11d0, 0xaf, 0xb9, 0x0, 0xaa, 0x0, 0xb6, 0x7a, 0x42);

#endif


// {E1D7E0DB-36CC-4367-A298-266B1D3DD355}
DEFINE_GUID(CLSID_DVIrisDSPropertyPage,
0xe1d7e0db, 0x36cc, 0x4367, 0xa2, 0x98, 0x26, 0x6b, 0x1d, 0x3d, 0xd3, 0x55);

#ifndef __IID_IDVIris__
#define __IID_IDVIris__

	// {9233606C-FDF1-40f1-8345-B7281F2FA486}
	DEFINE_GUID(IID_IDVIris,
	0x9233606c, 0xfdf1, 0x40f1, 0x83, 0x45, 0xb7, 0x28, 0x1f, 0x2f, 0xa4, 0x86);

	DECLARE_INTERFACE_(IDVIris, IUnknown)
	{

        STDMETHOD(get_CodecFlag) (THIS_
					DWORD *pdwFlag
                 ) PURE;

        STDMETHOD(put_CodecFlag) (THIS_
					DWORD dwFlag
                 ) PURE;

        STDMETHOD(get_ForceRGB) (THIS_
					BOOL *pbFlag
                 ) PURE;

        STDMETHOD(put_ForceRGB) (THIS_
					BOOL bFlag
                 ) PURE;

        STDMETHOD(get_WideMode) (THIS_
					BOOL *pbFlag
                 ) PURE;

        STDMETHOD(put_WideMode) (THIS_
					BOOL bFlag
                 ) PURE;

        STDMETHOD(get_YCStraight) (THIS_
					BOOL *pbFlag
                 ) PURE;

        STDMETHOD(put_YCStraight) (THIS_
					BOOL bFlag
                 ) PURE;

        STDMETHOD(get_ErrorConcealment) (THIS_
					BOOL *pbFlag
                 ) PURE;

        STDMETHOD(put_ErrorConcealment) (THIS_
					BOOL bFlag
                 ) PURE;

        STDMETHOD(get_DetectRedBlock) (THIS_
					BOOL *pbFlag
                 ) PURE;

        STDMETHOD(put_DetectRedBlock) (THIS_
					BOOL bFlag
                 ) PURE;

        STDMETHOD(get_InstructionSet) (THIS_
					DWORD *pdwFlag
                 ) PURE;

        STDMETHOD(put_InstructionSet) (THIS_
					DWORD dwFlag
                 ) PURE;

        STDMETHOD(get_EsteemSNRatio) (THIS_
					BOOL *pbFlag
                 ) PURE;

        STDMETHOD(put_EsteemSNRatio) (THIS_
					BOOL bFlag
                 ) PURE;

        STDMETHOD(get_DropYCbCrAccuracy) (THIS_
					BOOL *pbFlag
                 ) PURE;

        STDMETHOD(put_DropYCbCrAccuracy) (THIS_
					BOOL bFlag
                 ) PURE;

	};

#endif

#ifdef __cplusplus
}
#endif

#endif // __IDVIRISDS__

